Instargram/Models/Publication.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Identity;

namespace Instargram.Models
{
    public class Publication : Entity
    {
        public string ImagePath { get; set; }

        public string Desc { get; set; }

        public int LikeCount { get; set; }

        public User User { get; set; }
        public string UserId { get; set; }

        public List<Comment> Comments { get; set; }
        public List<Like> Likes { get; set; }
    }
}

Instargram/ViewModels/PublicationViewModel.cs
using System.ComponentModel.DataAnnotations;
using Microsoft.AspNetCore.Http;

namespace Instargram.ViewModels
{
    public class PublicationViewModel
    {
        [Required]
        public IFormFile Image { get; set; }
        [Required]
        public string Description { get; set; }
    }
}

Instargram/Controllers/PublicationController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Instargram.Helper;
using Instargram.Models;
using Instargram.Repositories;
using Instargram.ViewModels;
using Microsoft.AspNetCore.Hosting;
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Identity.UI.Services;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;

namespace Instargram.Controllers
{
    public class PublicationController : Controller
    {
        private readonly IUnitOfWorkFactory _unitOfWorkFactory;
        private readonly UserManager<User> _userManager;
        private readonly IHostingEnvironment _hostingEnvironment;

        public PublicationController(
            UserManager<User> userManager,IHostingEnvironment hostingEnvironment, IUnitOfWorkFactory unitOfWorkFactory)
        {
            _userManager = userManager;
            _hostingEnvironment = hostingEnvironment;
            _unitOfWorkFactory = unitOfWorkFactory;
        }

        public IActionResult Create()
        {
            return View(new PublicationViewModel());
        }

        [HttpPost]
        public async Task<IActionResult> CreatePublication(PublicationViewModel model)
        {
            using (var unitOfWork = _unitOfWorkFactory.MakeUnitOfWork())
            {
                var user = await _userManager.FindByNameAsync(User.Identity.Name);
                Publication publication = new Publication
                {
                    Desc = model.Description,
                    LikeCount = 0,
                    UserId = user.Id,
                    ImagePath = await ImageHelper.SaveAvatarAndGetFullPath(user.Id, model.Image, 
                        0, _hostingEnvironment, Guid.NewGuid())
            };
                await unitOfWork.Publications.CreateAsync(publication);
                user.PublicationCount++;
                await _userManager.UpdateAsync(user);
                await unitOfWork.CompleteAsync();
                
                return RedirectToAction("Index", "Home");
            }
        }

        public async Task<IActionResult> Publications(string id)
        {
            using (var unitOfWork = _unitOfWorkFactory.MakeUnitOfWork())
            {
                var publications = await unitOfWork.Publications.GetAllAsync();
                var publ = publications.Where(c => c.UserId == id);
                return View(publ);
            }
            
        }

        public async Task<IActionResult> Details(int publicationId)
        {
            using (var unitOfWork = _unitOfWorkFactory.MakeUnitOfWork())
            {
                var publication = await unitOfWork.Publications.GetByIdAsync(publicationId);
                var user = await _userManager.FindByNameAsync(User.Identity.Name);
                var comments = await unitOfWork.Comments.GetAllAsync();
                var sortComments = comments.Where(c => c.PublicationId == publicationId);

                Comment comment = new Comment()
                {
                    Publication = publication,
                    UserId = user.Id,
                    User = user,
                    PublicationId = publication.Id,

                };
                ViewBag.Comments = sortComments;
                return View(comment);
            }
        }

        public async Task<IActionResult> Like(int publicationId, string userId)
        {
            using (var unitOfWork = _unitOfWorkFactory.MakeUnitOfWork())
            {   
                var likes = await unitOfWork.Likes.GetAllAsync();
                if(likes.Count == 0)
                {
                    Like like = new Like()
                    {
                        PublicationId = publicationId,
                        UserId = userId
                    };
                    await unitOfWork.Likes.CreateAsync(like);
                }
                var publication = await unitOfWork.Publications.GetByIdAsync(publicationId);
                if (publication.LikeCount != 0 && likes.Exists(c => c.UserId == userId &&
                                                                    c.PublicationId == publicationId))
                {
                    publication.LikeCount--;
                    var allLikes = await unitOfWork.Likes.GetAllAsync();
                    var like = likes.FirstOrDefault(c =>
                        c.UserId == userId && c.PublicationId == publicationId);
                    unitOfWork.Likes.RemoveAsync(like);
                }
                else
                {
                    publication.LikeCount++;
                }
                await unitOfWork.CompleteAsync();
                return RedirectToAction("Details", "Publication", new {publicationId});
            }
                
        }
    }
}

Instargram/Controllers/ReviewController.cs
using System.Threading.Tasks;
using Instargram.Models;
using Instargram.Repositories;
using Microsoft.AspNetCore.Mvc;

namespace Instargram.Controllers
{
    public class ReviewController : Controller
    {
        private IUnitOfWorkFactory UnitOfWorkFactory { get; set; }
        public ReviewController(IUnitOfWorkFactory unitOfWorkFactory)
        {
            UnitOfWorkFactory = unitOfWorkFactory;
        }

        
        public async Task<IActionResult> CreateReview(Comment comment)
        {
            using (var unitOfWork = UnitOfWorkFactory.MakeUnitOfWork())
            {
                await unitOfWork.Comments.CreateAsync(comment);
                await unitOfWork.CompleteAsync();

                return RedirectToAction("Details", "Publication", new{ comment.PublicationId });
            }
        }
    }
}

Instargram/Views/Publication/Create.cshtml
@model Instargram.ViewModels.PublicationViewModel

<h1>Create</h1>

<h4>Publication</h4>
<hr />
<div class="row">
    <div class="col-md-4">
        <form asp-action="CreatePublication" method="post" enctype="multipart/form-data">
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
            <div class="form-group">
                <label asp-for="Image" class="control-label"></label>
                <input asp-for="Image" class="form-control-file" />
                <span asp-validation-for="Image" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Description" class="control-label"></label>
                <input asp-for="Description" class="form-control" />
                <span asp-validation-for="Description" class="text-danger"></span>
            </div>
            <div class="form-group">
                <input type="submit" value="Create" class="btn btn-primary" />
            </div>
        </form>
    </div>
</div>

<div>
    <a asp-action="Index" asp-controller="Home">Back to List</a>
</div>

Instargram/Views/Publication/Details.cshtml
@using System.Collections
@model Comment
<!DOCTYPE html>

<html>
<head>
    <title>@Model.Id</title>
</head>
<body>
<div>
    <img src="~/@Model.Publication.ImagePath"/>
    <p>@Model.Publication.Desc</p>
    <p>Лайков : @Model.Publication.LikeCount</p>
    <form asp-action="Like" asp-controller="Publication" asp-route-publicationId="@Model.PublicationId" asp-route-userId="@Model.UserId">
        <input type="button" onclick="this.disabled=true, this.form.submit() "style="font-weight: bolder; border-radius: 3px;" value="Лайкнуть"/>
    </form>
    
    @foreach(var comment in (IEnumerable<Comment>) ViewBag.Comments)
    {
        <p>@comment.AuthorName : </p>
        <p> @comment.Text </p>
    }
</div>
<b>Комментировать :</b>
<hr>
    <div class="col-md-4">
        <form asp-action="CreateReview" asp-controller="Review">
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
                <div class="form-group">
                    <input type="hidden" name="AuthorName" value="@Model.User.Name"/>
                </div>
        <div class="form-group">
            <label asp-for="@Model.Text" class="control-label">Сообщение</label>
            <input asp-for="@Model.Text" class="form-control"/>
            <span asp-validation-for="@Model.Text" class="text-danger"></span>
        </div>
            <div class="form-group">
                <input type="hidden" asp-for="@Model.UserId"/>
            </div>
            <div class="form-group">
                <input type="hidden" asp-for="@Model.PublicationId"/>
            </div>
        <div class="form-group">
            <input type="submit" value="Ответить" class="btn btn-primary"/>
        </div>
        </form>
    </div>
</body>
</html>

Instargram/Views/Publication/Publications.cshtml
@model IEnumerable<Publication>

<div class="row">
@foreach (var item in Model)
{
    <div class="col-12 py-3 col-sm-6 col-md-4 col-lg-3">
        <div class="card" style="padding: 10px;">
           <a asp-controller="Publication" asp-action="Details" asp-route-publicationId="@item.Id"><img class="card-img-top" src="~/@item.ImagePath" alt=""></a> 
            <div class="card-body">
                <p>@item.Desc</p>
            </div>
        </div>
    </div>
}
</div>